<template>
  <mt-connexion-template>
    <template v-slot:partie-droite>
      <section v-if="!next && !errorToken">
        <form @submit.prevent="suivantprecedent">
          <h2 class="mini-padding">S'inscrire</h2>
          <div class="columns is-multiline">
            <b-field label="Nom" class="column is-half ">
              <b-input key="user-nom" v-model="user.nom" placeholder="Nom" required class="input-login" />
            </b-field>
            <b-field label="Prénom" class="column is-half">
              <b-input key="user-prenom" v-model="user.prenom" placeholder="Prénom" required class="input-login" />
            </b-field>
            <mt-message-info class="has-text-weight-bold"
              >Pour des raisons de sécurité, votre grade ne doit pas être renseigné.</mt-message-info
            >
            <b-field label="E-mail " class="column is-full ">
              <b-input
                key="user-email"
                v-model="user.email"
                disabled="disabled"
                placeholder="E-mail"
                type="email"
                required
                class="input-login"
              />
            </b-field>

            <b-field label="téléphone" class="column is-half">
              <b-input
                key="user-telephone"
                v-model="user.telephone"
                placeholder="téléphone"
                required
                class="input-login"
              />
            </b-field>
            <div
              v-for="(organisme, index) in user.organismes"
              :key="index"
              class="field column is-half is-flex select-login"
            >
              <b-field :label="organisme.libelleTypeOrganisme">
                <b-select disabled="disabled" :placeholder="organisme.code">
                  <option>
                    {{ organisme.code }}
                  </option>
                </b-select>
              </b-field>
            </div>
            <div class="field column is-half is-flex select-login">
              <b-field label="Catégories">
                <b-select v-model="user.corps" placeholder="Sélectionnez">
                  <option v-for="corp in corps" :key="corp.id" :value="corp.id">
                    {{ corp.libelle }}
                  </option>
                </b-select>
              </b-field>
            </div>
          </div>
          <b-button
            key="next"
            class="mt-button is-uppercase is-size-7 has-text-weight-semibold"
            type="is-primary"
            native-type="submit"
            :disabled="disableFirstPage"
          >
            Suivant
          </b-button>
        </form>
      </section>
      <section v-if="next && !errorToken">
        <form @submit.prevent="inscrire()">
          <b-field label="Mot de passe">
            <b-input
              key="user-password"
              v-model="user.password"
              placeholder="Mot de passe"
              type="password"
              password-reveal
              required
              class="input-login"
            />
          </b-field>

          <b-field label="confirmez le Mot de passe">
            <b-input
              key="user-password-confirmation"
              v-model="user.passwordconfirmation"
              placeholder="Mot de passe"
              type="password"
              password-reveal
              required
              class="input-login"
            />
            <div class="control">
              <p v-if="erreur" class="help is-danger">{{ erreur }}</p>
            </div>
          </b-field>

          <mt-password-security-meter :password="user.password" :rules="rules"></mt-password-security-meter>

          <div class="columns accepte-infos">
            <b-field class="column is-narrow">
              <b-checkbox v-model="user.accordInscription" required></b-checkbox>
            </b-field>
            <p class="column has-text-justified is-size-7">
              * En soumettant ce formulaire, j’accepte que les informations saisies soient exploitées dans le cadre de
              la gestion de votre demande. Vous disposez d’un droit d’accès, de rectification, de suppression,
              limitation et d’opposition conformément à la réglementation sur la protection des données à caractère
              personnel.
            </p>
          </div>

          <div class="columns">
            <b-button
              class="mt-button is-size-7 column is-narrow has-text-weight-semibold"
              type="is-secondary"
              native-type="button"
              @click="suivantprecedent"
            >
              retour
            </b-button>

            <b-button
              class="mt-button is-size-7 column is-narrow has-text-weight-semibold"
              type="is-primary"
              native-type="submit"
              :disabled="disableSecondPage"
            >
              Valider
            </b-button>
          </div>
        </form>
      </section>
      <section v-if="errorToken">
        <h2>Cette invitation a expiré :'(</h2>
        <p>Soit elle a été annulée, soit vous avez dépassé le délai de <b>15 jours</b></p>
        <p>pour valider votre compte.</p>
        <p>Contactez votre hiérarchie pour renouveler votre email d'invitation.</p>
        <br />
        <p class="has-text-left">
          À bientôt, <br />
          L’équipe METIIS.
        </p>

        <nuxt-link :to="{ name: 'index' }" class="button mt-button is-size-7 is-primary"
          >Retour à la page d'accueil</nuxt-link
        >
      </section>
      <mt-modal-ok
        :ouvert.sync="ouvert"
        titre="Votre compte utilisateur a bien été créé."
        button="Retour à l’accueil"
        class-button=""
        @action="retourAccueil"
      >
        Un email de confirmation de création de compte vous a été envoyé.
      </mt-modal-ok>
    </template>
  </mt-connexion-template>
</template>

<script>
import MtConnexionTemplate from '~/components/connexion/connexion-template';
import MtPasswordSecurityMeter from '~/components/connexion/password-security-meter';
import MtModalOk from '~/components/modal/mt-modal-ok';
import passwordRulesMixin from '~/components/mixins/passwordRulesMixin';
import MtMessageInfo from '~/components/base/message/mt-message-info';

export default {
  layout: 'simple',
  auth: false,
  components: {
    MtModalOk,
    MtConnexionTemplate,
    MtPasswordSecurityMeter,
    MtMessageInfo,
  },
  mixins: [passwordRulesMixin],
  data() {
    return {
      ouvert: false,
      next: false,
      erreur: null,
    };
  },
  computed: {
    disableFirstPage() {
      return !this.user.nom || !this.user.prenom || !this.user.corps || !this.user.telephone;
    },
    disableSecondPage() {
      return !this.user.password || !this.user.passwordconfirmation || !this.user.accordInscription;
    },
  },
  async asyncData({ $api, params }) {
    const { token } = params;
    let errorToken;
    let user = {};
    let corps = [];
    try {
      [user, corps] = await Promise.all([
        $api.utilisateurs.getConfirmationInscription(params.token),
        $api.corps.full(),
      ]);
    } catch ({
      response: {
        status,
        data: { message },
      },
    }) {
      errorToken = { status, message };
    }
    return {
      errorToken,
      token,
      user,
      corps,
    };
  },
  methods: {
    suivantprecedent() {
      this.next = !this.next;
    },
    async inscrire() {
      try {
        if (this.user.password !== this.user.passwordconfirmation) {
          this.erreur = 'Les mots de passe doivent être identiques';
        } else {
          this.user.login = this.user.email;
          this.user.idorganisme = this.user.organismes[this.user.organismes.length - 1];
          this.erreur = '';

          await this.$api.utilisateurs.postConfirmationInscription(this.user);
          this.ouvert = true;
        }
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    retourAccueil() {
      this.$router.push('/');
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.field.has-addons {
  display: block;

  /deep/ input {
    border-radius: 4px !important;
  }
}

.accepte-infos {
  margin-top: 0.5rem;
  color: #60666a;
  line-height: 1.31;
}
/deep/ .column.field:not(:last-child) {
  margin-bottom: 0;
}
</style>
